/*
 * Copyright 2012 by The Cogchar Project (www.cogchar.org).
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * ConversationMonitorPanel.java
 *
 * Created on Apr 24, 2012, 6:13:09 PM
 */
package org.cogchar.bundle.demo.convo.ui;

import org.cogchar.bundle.demo.convo.ConvoResponse;
import org.jflux.api.core.Listener;
import org.jflux.api.core.Notifier;

/**
 *
 * @author Matthew Stevenson <www.robokind.org>
 */
public class ConversationMonitorPanel extends javax.swing.JPanel {

    /** Creates new form ConversationMonitorPanel */
    public ConversationMonitorPanel() {
        initComponents();
    }
    
    public Listener<ConvoResponse> getConvoResponseListener(){
        return conversationLogPanel1.getConvoResponseListener();
    }
    
    public Notifier<String> getConvoInputNotifier(){
        return conversationInputPanel1.getConvoInputNotifier();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        conversationInputPanel1 = new org.cogchar.bundle.demo.convo.ui.ConversationInputPanel();
        conversationLogPanel1 = new org.cogchar.bundle.demo.convo.ui.ConversationLogPanel();

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(conversationInputPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 285, Short.MAX_VALUE)
            .addComponent(conversationLogPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 285, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(conversationInputPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(conversationLogPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 152, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.cogchar.bundle.demo.convo.ui.ConversationInputPanel conversationInputPanel1;
    private org.cogchar.bundle.demo.convo.ui.ConversationLogPanel conversationLogPanel1;
    // End of variables declaration//GEN-END:variables
}
